// JavaScript Document

var dir;

$(function(){

	$.fn.infiniteslide = function(options) {
	
	if ( options == 0 ) {
		dir = "left";
	} else {
		dir = "right";
	}

	var settings = $.extend( {
			'speed': 30,
			'direction' : dir,
			'pauseonhover': false
			}, options);

	var opening = function(obj){
		var d = new $.Deferred;

		var ul = obj.find('ul');
		var li = obj.find('li');

		i = 0;
		obj.find('img').each(function(key,value){
			$('<img />').attr('src',$(this).attr('src'));
			i = i + parseInt($(this).width());
		});

		obj.css({
			overflow: 'hidden'
		});
		ul.css({
			width: i*2 + 'px',
			height: settings.height + 'px',
			position: 'relative',
			overflow: 'hidden'
		}).children('li').css({
			display: 'inline',
			float: 'left'
		});
		
		li.hide().each(function(key,value){
			$(this).delay(key*200).fadeIn('slow',function(){
				$(this).clone().css('display','inline').appendTo(ul);
			});
		});
		
		d.resolve();
		return d.promise();
	}


	var slide = function(obj){
		var d = new $.Deferred;
		var ul = obj.children('ul');
		
		if(settings.direction == 'right'){
			ul.css('left',-1*ul.width()/2 + 'px');
		}
		
		var anim = function(){
			if(settings.direction == 'left'){
				ul.animate({
					left: '-' + ul.width()/2 + 'px'
					},ul.width()/2*settings.speed,'linear',function(){
					ul.css('left',0);
					anim();
				});
			} else if(settings.direction == 'right'){
				ul.animate({
					left: '0px'
					},ul.width()/2*settings.speed,'linear',function(){
					ul.css('left',-1*ul.width()/2 + 'px');
					anim();
				});
			}
			
			if(settings.pauseonhover){
				ul.on('mouseenter',function(){
					$(this).pause();
				}).on('mouseleave',function(){
					$(this).resume();
				});
			}
		}
		
		anim();
		return d.promise();
	}

		return this.each(function() {
			opening($(this)).then(slide($(this)));
		});

	  };
});

(function(){var e=jQuery,f="jQuery.pause",d=1,b=e.fn.animate,a={};function c(){return new Date().getTime()}e.fn.animate=function(k,h,j,i){var g=e.speed(h,j,i);g.complete=g.old;return this.each(function(){if(!this[f]){this[f]=d++}var l=e.extend({},g);b.apply(e(this),[k,e.extend({},l)]);a[this[f]]={run:true,prop:k,opt:l,start:c(),done:0}})};e.fn.pause=function(){return this.each(function(){if(!this[f]){this[f]=d++}var g=a[this[f]];if(g&&g.run){g.done+=c()-g.start;if(g.done>g.opt.duration){delete a[this[f]]}else{e(this).stop();g.run=false}}})};e.fn.resume=function(){return this.each(function(){if(!this[f]){this[f]=d++}var g=a[this[f]];if(g&&!g.run){g.opt.duration-=g.done;g.done=0;g.run=true;g.start=c();b.apply(e(this),[g.prop,e.extend({},g.opt)])}})}})();